##########################################
# Modles linaires  effets alatoires  #
##########################################

rm(list=ls()) # Efface compltement la mmoire

########## Exercice 5: cas d'un facteur alatoire

# # Lecture des donnes dans R
donnee5=read.table('clipboard',h=T) 		# Importe la matrice de donnes dans R
attach(donnee5) 				# Individualise les colonnes (variables) de la matrice de sorte qu'on puisse les manipuler separement
names(donnee5) 					# Affiche la matrice de donnes dans R

# Dfinition des facteurs
LEAF=as.factor(LEAF) 				# Dfini comme facteur
DISC=as.factor(DISC) 				# Dfini comme facteur
mydata1=data.frame(LEAF,DISC,CACONC) 		# construction de tableau

# # Application d'un modle linaire  effet alatoire

library(lmerTest) 				# Chargement du package lmerTest
model5=lmer(CACONC~1+(1|LEAF), data=mydata1) 	# Excution du modle

# Prsentation des rsultats
summary(model5) 				# Rsultat global
rand(model5) 					# Tableau d'analyse de l'effet alatoire (LEAF)
fixef(model5) 					# Affiche le coefficient de l'effet fixe (effet fixe moyen)
ranef(model5) 					# Affiche l'intercept de chaque modalit de LEAF
coef(model5)  					# Affiche le coefficient de chaque modalit de LEAF


########## Exercice 6: cas d'un facteur alatoire LEAF et un autre qui lui est subordonn(DISC)#

rm(list=ls()) 					# Efface compltement la mmoire

# Lecture des donnees dans R
donnee6=read.table('clipboard',h=T) 
attach(donnee6)
names(donnee6)
DISC=as.factor(DISC) 				# Dfinir DISC comme facteur
LEAF=as.factor(LEAF) 				# Dfinir LEAF comme facteur
mydata2=data.frame(LEAF,DISC,CACONC)  		# construction de tableau

library(lmerTest)  					# Chargement du package lmerTest
model6=lmer(CACONC~1+(1|LEAF/DISC),data=mydata2) 	# Excution du modle

# Prsentation des rsultats
summary(model6) 					# Rsultat global (ici pour attirer votre attention sur l'utilit de la rptition des observations)



########## Exercice 7: cas d'un facteur alatoire Forest et un autre qui lui est subordonn(Tree)#

rm(list=ls()) 					# Efface compltement la mmoire

# Lecture des donnees dans R
donnee7=read.table('clipboard',sep='\t',h=T)
attach(donnee7)
names(donnee7)

library(lmerTest) 				# Chargement du package lmerTest
model7=lmer(Height~1+(1|Forest/Tree)) 		# Excution du modle

# Prsentation des rsultats
summary(model7)
rand(model7)