####################################
# Modles linaires  effets fixes #
####################################

rm(list=ls()) # Efface compltement la mmoire


########## Exercice 1: Cas d'un facteur
#######################################

## Importation des donnes et empilement
fixe1f<-read.table("clipboard",sep="\t",h=T) 		# Importation la matrice de donnes dans R
fixe1f<-stack(fixe1f) 					# Empilage des donnes
str(fixe1f) 						# Vrification de la structure des donnes
colnames(fixe1f)<-(c("hauteur","fort"));fixe1f 	# Renomme les colonnes obtenues aprs empilage 
attach(fixe1f) 						# Individualisation des colonnes (variables) de la matrice de sorte qu'on puisse les manipuler separement
fixe1f  						# Affiche la matrice de donnes dans R
          
## Modle linaire  ffet fixe  un facteur
model3 <- lm(hauteur~fort) 				# Excution du modle

# Prsentation des rsultats
summary(model3)


## Quelques cas de comparaison multiple de moyennes 

# test de STUDENT NEWMAN et KEULS (SNK)
library(agricolae) 					# Chargement de la bibliothque agricolae
SNK=SNK.test(model3,'fort') 				# Excution du test
SNK 							# Affichage des rsultats

## Ralisation sous forme de graphe (bar.group) des rsultats de Tukey HSD (Honestly Significant Difference)
out <- HSD.test(model3,"fort",group=TRUE,console=TRUE) 						# Excution dt test Tukey HSD 
bar.group(out$groups,density=4,border="blue",xlab='Fort',ylab='Hauteur (m)',ylim=c(0,28.5)) 		# Ralisation du graphe

 
## Construction et ralisation de contrasts
library(gmodels) 						# Chargement de la bibliothque gmodels
fit.contrast(model3, "fort", c(1,-2,1), conf.int=0.95 ) 	# teste FClaire	vs	FSemiD et FDense
fit.contrast(model3, "fort", c(1,0,-1), conf.int=0.95 ) 	# teste FClaire	vs	FSemiD 
fit.contrast(model3, "fort", c(0,-1,1), conf.int=0.95 ) 	# teste FSemiD vs FDense
 
## Ralisation du test de Dunnett pour comparer la moyenne d'un contrle (fort Claire, 'FClaie')  toutes les autres
library(multcomp) 						# Chargement de la bibliothque multcomp
ph<- glht(model3, linfct = mcp('fort'="Dunnett")) 		# Excution du test
confint(ph, level = 0.95) 					# Defini l'intervalle de confiance
  
## Ralisation de Barplot surmont de barres d'erreurs
m1P <- tapply(hauteur,fort, mean) 							# Calcul de la moyenne pour chaque type de fort
v1P <- tapply(hauteur,fort, var)  							# Calcul de la variance pour chaque type de fort
d1P <- qt(.95, df=(length(hauteur)-3))*sqrt(v1P/length(hauteur)) 			# intervalles de confiance  95%
mp1P <- barplot(m1P, ylim=c(0,30), xpd=F, xlab="Type de fret", ylab='hauteur (m)') 	# Ralisation de barplot
arrows(mp1P, m1P-d1P, mp1P, m1P+d1P, angle=90, code=3) 					# Surmontage des barres d'erreurs

## Spcification du type de calcul de la somme des carr des carts (SCE)
library(car) 										# Chargement de la bibliothque car
model3 <- lm(hauteur~fort) 								# Excution du modle
Anova(model3,type=3) 									# test de type III
 
 
  

##### Exercice 2: u autre cas d'un facteur	
##########################################
  
rm(list=ls()) # Efface compltement la mmoire

# Lecture des donnees dans R
mydata=read.table("clipboard",h=T) 							# Importe la matrice de donnes dans R
mydata                             							# Affiche la matrice de donnes dans R
attach(mydata)                     							# Individualise les colonnes (variables) de la matrice de sorte qu'on puisse les manipuler separement
names(mydata)                      							# Affiche les noms des colonnes (variables) de la matrice
model = lm(frequence ~ sex, mydata) 							# Excution du modle
summary(model)
mean(mydata[mydata$sex=="female",]$frequence)						# pour dterminer la frquence moyenne (Hz) chez les "females"

# Ralisation de boxplot
boxplot(frequence~sex,notch=T)

# Ralisation de Barplot surmont de barres d'erreurs
m1P <- tapply(frequence,sex, mean)
v1P <- tapply(frequence,sex, var)
d1P <- qt(.95, df=(length(frequence)-2))*sqrt(v1P/length(frequence)) 			# intervalles de confiance  95%
mp1P <- barplot(m1P, ylim=c(0,30), xpd=F, xlab="Type de fret", ylab='hauteur (m)')
arrows(mp1P, m1P-d1P, mp1P, m1P+d1P, angle=90, code=3)




##### Exercice 3: cas de 2 facteurs fixes sans interaction
##########################################################

rm(list=ls()) 							# Efface compltement la mmoire

# Importation et affichage des donnes
donnee1<-read.table("clipboard",header=TRUE)			#Importe la matrice de donnes dans R
attach(donnee1)     						# Individualise les colonnes (variables) de la matrice de sorte qu'on puisse les manipuler separement
names(donnee1)       						# Affiche les noms des colonnes (variables) de la matrice
donnee1             						# Affiche la matrice de donnes dans R

# Implmenation du modle
modele3<-lm(rmt~azote+phosphore) 				# Excution du modle

# Affichage des rsultats
summary(modele3) 

# Ralisation des boxplots cte  cte :
par(mfrow=c(1,2))
plot(rdmt~azote+phosphore)

# Application avec le seul facteur significatif
modele33<-lm(rdmt~azote) 					# Excution du modle

# Affichage des rsultats
anova(modele33)
summary(modele33)

# Structuration de moyennes: SNK test
library(agricolae) 						# Chargement de la bibliothque agricolae
SNK.test(model,'fort') 					# Execution du test




##### Exercice 4: cas de 2 facteurs fixes avec rptitions
##########################################################

# Importation et affichage des donnes
donnee4<-read.table("clipboard",header=TRUE)			# Importe la matrice de donnes dans R
attach(donnee4)     						# Individualise les colonnes (variables) de la matrice de sorte qu'on puisse les manipuler separement
names(donnee4)       						# Affiche les noms des colonnes (variables) de la matrice
donnee4             						# Affiche la matrice de donnes dans R

# Implmentation du modle d'anova
modele4=lm(rdmt~azote*phosphore) 				# Excution

# Affichage des rsultats
summary(modele4)

# Etablissement du diagramme d'interaction (valable si interaction significative)
library(lsmeans) 						# Chargement de la bibliothque lmeans
lsmip(modele4, azote~phosphore) 				# graphe
lsmeans(modele4, pairwise~azote*phosphore, adjust="tukey")	# comparaison des moyennes ajustes

# Comparaison des moyennes arithmtiques
interaction.plot(phosphore,azote,rdmt) 				# Valable pour les plans quilibrs